# Folders with both manual changes allowed and destroy protection
resource "grafana_folder" "folders_ignore_and_protect" {
  for_each = local.folders_ignore_and_protect

  title  = each.value.dashboard_alert_group_name
  org_id = var.org_id

  lifecycle {
    ignore_changes  = [title]
    prevent_destroy = true
  }
}

# Folders with only manual changes allowed
resource "grafana_folder" "folders_ignore_only" {
  for_each = local.folders_ignore_only

  title  = each.value.dashboard_alert_group_name
  org_id = var.org_id

  lifecycle {
    ignore_changes = [title]
  }
}

# Folders with only destroy protection
resource "grafana_folder" "folders_protect_only" {
  for_each = local.folders_protect_only

  title  = each.value.dashboard_alert_group_name
  org_id = var.org_id

  lifecycle {
    prevent_destroy = true
  }
}

# Standard folders without any special lifecycle management
resource "grafana_folder" "folders_standard" {
  for_each = local.folders_standard

  title  = each.value.dashboard_alert_group_name
  org_id = var.org_id
}
